// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignVisualization.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_global_align_visualization__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `landmarks`
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_visualization_information__functions.h"
// Member `observations`
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_observation_notice__functions.h"

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  // visualization_id
  // landmarks
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__init(&msg->landmarks, 0)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  // observations
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__init(&msg->observations, 0)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // visualization_id
  // landmarks
  bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__fini(&msg->landmarks);
  // observations
  bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__fini(&msg->observations);
}

bosch_locator_bridge__msg__ClientGlobalAlignVisualization *
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__create()
{
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization *)malloc(sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization));
  bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__destroy(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  if (msg) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
  }
  free(msg);
}


bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__init(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization * data = NULL;
  if (size) {
    data = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization *)calloc(size, sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__fini(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence *
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__create(size_t size)
{
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence *)malloc(sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__destroy(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array)
{
  if (array) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__fini(array);
  }
  free(array);
}
