// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from bosch_locator_bridge:srv/ClientMapList.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_LIST__FUNCTIONS_H_
#define BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_LIST__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "bosch_locator_bridge/msg/rosidl_generator_c__visibility_control.h"

#include "bosch_locator_bridge/srv/detail/client_map_list__struct.h"

/// Initialize srv/ClientMapList message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * bosch_locator_bridge__srv__ClientMapList_Request
 * )) before or use
 * bosch_locator_bridge__srv__ClientMapList_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__srv__ClientMapList_Request__init(bosch_locator_bridge__srv__ClientMapList_Request * msg);

/// Finalize srv/ClientMapList message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Request__fini(bosch_locator_bridge__srv__ClientMapList_Request * msg);

/// Create srv/ClientMapList message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * bosch_locator_bridge__srv__ClientMapList_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__srv__ClientMapList_Request *
bosch_locator_bridge__srv__ClientMapList_Request__create();

/// Destroy srv/ClientMapList message.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Request__destroy(bosch_locator_bridge__srv__ClientMapList_Request * msg);


/// Initialize array of srv/ClientMapList messages.
/**
 * It allocates the memory for the number of elements and calls
 * bosch_locator_bridge__srv__ClientMapList_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__srv__ClientMapList_Request__Sequence__init(bosch_locator_bridge__srv__ClientMapList_Request__Sequence * array, size_t size);

/// Finalize array of srv/ClientMapList messages.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Request__Sequence__fini(bosch_locator_bridge__srv__ClientMapList_Request__Sequence * array);

/// Create array of srv/ClientMapList messages.
/**
 * It allocates the memory for the array and calls
 * bosch_locator_bridge__srv__ClientMapList_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__srv__ClientMapList_Request__Sequence *
bosch_locator_bridge__srv__ClientMapList_Request__Sequence__create(size_t size);

/// Destroy array of srv/ClientMapList messages.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Request__Sequence__destroy(bosch_locator_bridge__srv__ClientMapList_Request__Sequence * array);

/// Initialize srv/ClientMapList message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * bosch_locator_bridge__srv__ClientMapList_Response
 * )) before or use
 * bosch_locator_bridge__srv__ClientMapList_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__srv__ClientMapList_Response__init(bosch_locator_bridge__srv__ClientMapList_Response * msg);

/// Finalize srv/ClientMapList message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Response__fini(bosch_locator_bridge__srv__ClientMapList_Response * msg);

/// Create srv/ClientMapList message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * bosch_locator_bridge__srv__ClientMapList_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__srv__ClientMapList_Response *
bosch_locator_bridge__srv__ClientMapList_Response__create();

/// Destroy srv/ClientMapList message.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Response__destroy(bosch_locator_bridge__srv__ClientMapList_Response * msg);


/// Initialize array of srv/ClientMapList messages.
/**
 * It allocates the memory for the number of elements and calls
 * bosch_locator_bridge__srv__ClientMapList_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__srv__ClientMapList_Response__Sequence__init(bosch_locator_bridge__srv__ClientMapList_Response__Sequence * array, size_t size);

/// Finalize array of srv/ClientMapList messages.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Response__Sequence__fini(bosch_locator_bridge__srv__ClientMapList_Response__Sequence * array);

/// Create array of srv/ClientMapList messages.
/**
 * It allocates the memory for the array and calls
 * bosch_locator_bridge__srv__ClientMapList_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__srv__ClientMapList_Response__Sequence *
bosch_locator_bridge__srv__ClientMapList_Response__Sequence__create(size_t size);

/// Destroy array of srv/ClientMapList messages.
/**
 * It calls
 * bosch_locator_bridge__srv__ClientMapList_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__srv__ClientMapList_Response__Sequence__destroy(bosch_locator_bridge__srv__ClientMapList_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_LIST__FUNCTIONS_H_
