// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:srv/ClientMapStart.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/srv/detail/client_map_start__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `recording_name`
// Member `client_map_name`
#include "rosidl_runtime_c/string_functions.h"

bool
bosch_locator_bridge__srv__ClientMapStart_Request__init(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  if (!msg) {
    return false;
  }
  // recording_name
  if (!rosidl_runtime_c__String__init(&msg->recording_name)) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
    return false;
  }
  // client_map_name
  if (!rosidl_runtime_c__String__init(&msg->client_map_name)) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__fini(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  if (!msg) {
    return;
  }
  // recording_name
  rosidl_runtime_c__String__fini(&msg->recording_name);
  // client_map_name
  rosidl_runtime_c__String__fini(&msg->client_map_name);
}

bosch_locator_bridge__srv__ClientMapStart_Request *
bosch_locator_bridge__srv__ClientMapStart_Request__create()
{
  bosch_locator_bridge__srv__ClientMapStart_Request * msg = (bosch_locator_bridge__srv__ClientMapStart_Request *)malloc(sizeof(bosch_locator_bridge__srv__ClientMapStart_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__srv__ClientMapStart_Request));
  bool success = bosch_locator_bridge__srv__ClientMapStart_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__destroy(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  if (msg) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
  }
  free(msg);
}


bool
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__init(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  bosch_locator_bridge__srv__ClientMapStart_Request * data = NULL;
  if (size) {
    data = (bosch_locator_bridge__srv__ClientMapStart_Request *)calloc(size, sizeof(bosch_locator_bridge__srv__ClientMapStart_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__srv__ClientMapStart_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__srv__ClientMapStart_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__fini(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__srv__ClientMapStart_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__srv__ClientMapStart_Request__Sequence *
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__create(size_t size)
{
  bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array = (bosch_locator_bridge__srv__ClientMapStart_Request__Sequence *)malloc(sizeof(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__destroy(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array)
{
  if (array) {
    bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__fini(array);
  }
  free(array);
}


bool
bosch_locator_bridge__srv__ClientMapStart_Response__init(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__fini(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bosch_locator_bridge__srv__ClientMapStart_Response *
bosch_locator_bridge__srv__ClientMapStart_Response__create()
{
  bosch_locator_bridge__srv__ClientMapStart_Response * msg = (bosch_locator_bridge__srv__ClientMapStart_Response *)malloc(sizeof(bosch_locator_bridge__srv__ClientMapStart_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__srv__ClientMapStart_Response));
  bool success = bosch_locator_bridge__srv__ClientMapStart_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__destroy(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  if (msg) {
    bosch_locator_bridge__srv__ClientMapStart_Response__fini(msg);
  }
  free(msg);
}


bool
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__init(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  bosch_locator_bridge__srv__ClientMapStart_Response * data = NULL;
  if (size) {
    data = (bosch_locator_bridge__srv__ClientMapStart_Response *)calloc(size, sizeof(bosch_locator_bridge__srv__ClientMapStart_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__srv__ClientMapStart_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__srv__ClientMapStart_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__fini(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__srv__ClientMapStart_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__srv__ClientMapStart_Response__Sequence *
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__create(size_t size)
{
  bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array = (bosch_locator_bridge__srv__ClientMapStart_Response__Sequence *)malloc(sizeof(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__destroy(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array)
{
  if (array) {
    bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__fini(array);
  }
  free(array);
}
